﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using Infragistics.WebUI.UltraWebGrid;
using System.Collections.Generic;
using Infragistics.WebUI.WebCombo;

public partial class Desenvolvimento_Infragistics : System.Web.UI.Page
{
    private UltraWebGrid _grid;

    protected override void CreateChildControls()
    {
        base.CreateChildControls();

        _grid = new UltraWebGrid();
        _grid.DisplayLayout.SelectTypeCellDefault = SelectType.Extended;
        _grid.DisplayLayout.BorderCollapseDefault = BorderCollapse.Separate;
        _grid.DisplayLayout.StationaryMargins = StationaryMargins.No;
        _grid.DisplayLayout.TableLayout = TableLayout.Auto;
        _grid.DisplayLayout.EnableInternalRowsManagement = false;
        _grid.DisplayLayout.Pager.PageSize = 10;
        _grid.DisplayLayout.EnableClientSideRenumbering = false;
        _grid.DisplayLayout.LoadOnDemand = LoadOnDemand.NotSet;
        _grid.DisplayLayout.ReadOnly = ReadOnly.NotSet;
        _grid.DisplayLayout.AllowSortingDefault = AllowSorting.Yes;
        _grid.DisplayLayout.HeaderClickActionDefault = HeaderClickAction.SortMulti;
        _grid.DisplayLayout.EnableInternalRowsManagement = false;
        _grid.SortColumn += new SortColumnEventHandler(SortColumn);
        UpdatePanel1.ContentTemplateContainer.Controls.Add(_grid);
    }

    private void SortColumn(object sender, SortColumnEventArgs e)
    {
        
    }

    private void CreateColumns()
    { 
        UltraGridColumn columnA = new UltraGridColumn();
        columnA.HeaderText = "Handle";
        columnA.BaseColumnName = "HANDLE";
        columnA.Key = "HANDLE";
        columnA.IsBound = true;
        columnA.SortIndicator = SortIndicator.None;
        columnA.AllowUpdate = AllowUpdate.Yes;
        columnA.Type = ColumnType.Custom;
        _grid.Columns.Add(columnA);

        UltraGridColumn columnB = new UltraGridColumn();
        columnB.HeaderText = "Name";
        columnB.BaseColumnName = "NAME";
        columnB.Key = "NAME";
        columnB.IsBound = true;
        columnB.AllowUpdate = AllowUpdate.Yes;
        columnB.Type = ColumnType.Custom;
        _grid.Columns.Add(columnB);

        UltraGridColumn columnC = new UltraGridColumn();
        columnC.HeaderText = "LookupA";
        columnC.BaseColumnName = "LOOKUPA";
        columnC.Key = "LOOKUPA";
        columnC.IsBound = true;
        columnC.AllowUpdate = AllowUpdate.Yes;
        columnC.Type = ColumnType.Custom;
        _grid.Columns.Add(columnC);
        CreateWebCombo("LookupA", columnC);

        UltraGridColumn columnD = new UltraGridColumn();
        columnD.HeaderText = "LookupB";
        columnD.BaseColumnName = "LOOKUPB";
        columnD.Key = "LOOKUPB";
        columnD.IsBound = true;
        columnD.AllowUpdate = AllowUpdate.Yes;
        columnD.Type = ColumnType.Custom;
        _grid.Columns.Add(columnD);
        CreateWebCombo("LookupB", columnD);
    }

    private void CreateWebCombo(string editorControlId,  UltraGridColumn column)
    {
        WebCombo combo = new WebCombo(editorControlId);
        combo.DropDownLayout.AutoGenerateColumns = false;
        combo.ComboTypeAhead = TypeAhead.None;
        combo.Editable = true;
        combo.ClientSideEvents.InitializeCombo = "WebCombo_InitializeCombo";
        combo.ClientSideEvents.AfterSelectChange = "WebCombo_AfterSelectChange";
        combo.ClientSideEvents.BeforeDropDown = "WebCombo_BeforeDropDown";
        combo.DataValueField = "HANDLE";
        combo.DataTextField = "RESULTFIELD";

        column.EditorControlID = editorControlId;

        UltraGridColumn keyColumn = new UltraGridColumn();
        keyColumn.HeaderText = "Handle";
        keyColumn.BaseColumnName = "HANDLE";
        keyColumn.Key = "HANDLE";
        keyColumn.IsBound = true;
        keyColumn.Type = ColumnType.Custom;
        combo.Columns.Add(keyColumn);

        UltraGridColumn displayColumn = new UltraGridColumn();
        displayColumn.HeaderText = "ResultField";
        displayColumn.BaseColumnName = "RESULTFIELD";
        displayColumn.Key = "RESULTFIELD";
        displayColumn.IsBound = true;
        displayColumn.Type = ColumnType.Custom;
        combo.Columns.Add(displayColumn);

        UpdatePanel1.ContentTemplateContainer.Controls.Add(combo);
    }

    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        CreateColumns();

        List<CustomData> entities = new List<CustomData>();
        entities.Add(new CustomData() { Handle = 100, Name = "Aaaaaa", LookupA = 645, LookupB = 50 });
        entities.Add(new CustomData() { Handle = 200, Name = "Bbbbbb", LookupA = 713, LookupB = 50 });
        entities.Add(new CustomData() { Handle = 300, Name = "Cccccc", LookupA = 800, LookupB = 50 });
        entities.Add(new CustomData() { Handle = 400, Name = "Dddddd", LookupA = 900, LookupB = 50 });
        entities.Add(new CustomData() { Handle = 500, Name = "Eeeeee", LookupA = 1113, LookupB = 50 });
        _grid.DataSource = entities;
        _grid.DataBind();
    }
}

public class CustomData
{
    public Int64 Handle { get; set; }
    public string Name { get; set; }
    public Int64 LookupA { get; set; }
    public Int64 LookupB { get; set; }
}
